#!/usr/bin/env node
"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander = __importStar(require("commander"));
const create_1 = __importDefault(require("./lib/create"));
const display_1 = __importDefault(require("./lib/display"));
const output_1 = __importDefault(require("./lib/output"));
const program = new commander.Command();
// Inherit version from the package.json
program.version(require('../package.json').version);
// Add debug flag for debugging
program
    .option('-c, --create', 'create performance budget')
    .option('-o, --output <output_path>', 'path to output file')
    .option('-d, --debug', 'output extra debugging');
// Add useful custom help text
program.on('--help', function () {
    console.log('');
    console.log('Examples:');
    console.log('  $ perfbudget --output budget.json');
});
// Allow commander to parse the args
program.parse(process.argv);
// For debugging purposes output the options and file path
if (program.debug) {
    console.log(Object.assign({}, program.opts()));
}
if (program.output) {
    console.log(program.output);
}
// Add useful custom help text
if (program.create) {
    create_1.default().then((budget) => {
        display_1.default(budget);
        if (program.output) {
            output_1.default(budget, program.output);
        }
        process.exit();
    });
}
