"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer = __importStar(require("inquirer"));
function validateNumber(input) {
    return __awaiter(this, void 0, void 0, function* () {
        const number = parseFloat(input);
        if (isNaN(number)) {
            console.log('');
            console.log('Please enter a number');
            return;
        }
        return true;
    });
}
function create() {
    return __awaiter(this, void 0, void 0, function* () {
        const config = yield inquirer.prompt([{
                message: 'How many seconds should your site load in?',
                name: 'seconds',
                validate: validateNumber,
            }, {
                message: 'What connection speed',
                name: 'speed',
                type: 'list',
                choices: [
                    { value: 4.375, name: 'Mobile 2G - Slow (35 Kbps)' },
                    { value: 7, name: '56K Dial-Up (49Kbps)' },
                    { value: 18.75, name: 'Mobile 2G - Fast (150 Kbps)' },
                    { value: 30, name: 'Mobile Edge (240 Kbps)' },
                    { value: 96, name: 'Mobile 3G - Slow (780 Kbps)' },
                    { value: 187.5, name: 'DSL (1.5Mbps)' },
                    { value: 200, name: 'Mobile 3G - Fast (1.6 Mbps)' },
                    { value: 625, name: 'Cable (5Mbps)' },
                    { value: 2500, name: 'FIOS (20Mbps)' },
                ],
            }]);
        const budget = config.seconds * config.speed;
        let avaliableBudget = budget;
        console.log(`Your total budget is ${budget}kb`);
        const html = yield inquirer.prompt([{
                message: `How many kb do you want to assign to HTML? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        avaliableBudget = avaliableBudget - html.kb;
        const css = yield inquirer.prompt([{
                message: `How many kb do you want to assign to CSS? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        avaliableBudget = avaliableBudget - css.kb;
        const javascript = yield inquirer.prompt([{
                message: `How many kb do you want to assign to JavaScript? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        avaliableBudget = avaliableBudget - javascript.kb;
        const images = yield inquirer.prompt([{
                message: `How many kb do you want to assign to images? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        avaliableBudget = avaliableBudget - images.kb;
        const fonts = yield inquirer.prompt([{
                message: `How many kb do you want to assign to fonts? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        avaliableBudget = avaliableBudget - fonts.kb;
        const video = yield inquirer.prompt([{
                message: `How many kb do you want to assign to video? (avaliable: ${avaliableBudget})?`,
                name: 'kb',
                validate: validateNumber,
            }]);
        return {
            css: parseFloat(css.kb),
            html: parseFloat(html.kb),
            javascript: parseFloat(javascript.kb),
            fonts: parseFloat(fonts.kb),
            images: parseFloat(images.kb),
            video: parseFloat(video.kb),
        };
    });
}
exports.default = create;
