"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cli_table_1 = __importDefault(require("cli-table"));
const speeds = [
    { value: 4.375, name: 'Mobile 2G - Slow (35 Kbps)' },
    { value: 7, name: '56K Dial-Up (49Kbps)' },
    { value: 18.75, name: 'Mobile 2G - Fast (150 Kbps)' },
    { value: 30, name: 'Mobile Edge (240 Kbps)' },
    { value: 96, name: 'Mobile 3G - Slow (780 Kbps)' },
    { value: 187.5, name: 'DSL (1.5Mbps)' },
    { value: 200, name: 'Mobile 3G - Fast (1.6 Mbps)' },
    { value: 625, name: 'Cable (5Mbps)' },
    { value: 2500, name: 'FIOS (20Mbps)' },
];
function display(budget) {
    return __awaiter(this, void 0, void 0, function* () {
        const budgetTable = new cli_table_1.default();
        let total = 0;
        const budgetKeys = Object.keys(budget);
        budgetKeys.forEach((key) => {
            const obj = {};
            obj[key] = `${budget[key]}kb`;
            total += parseFloat(budget[key]);
            budgetTable.push(obj);
        });
        const speedsTable = new cli_table_1.default();
        speeds.forEach((speed) => {
            speedsTable.push([
                speed.name,
                `${total / speed.value} secs`,
            ]);
        });
        console.log('');
        console.log('*** Your Budget ***');
        console.log(`Total: ${total}`);
        console.log(budgetTable.toString());
        console.log('');
        console.log('*** Loadtimes for budget ***');
        console.log(speedsTable.toString());
    });
}
exports.default = display;
