"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
function sumObjectValues(obj) {
    const keys = Object.keys(obj);
    let total = 0;
    keys.forEach((key) => {
        total += obj[key];
    });
    return total;
}
function buildJson(budget) {
    const total = sumObjectValues(budget);
    return `[
    {
      "resourceSizes": [
        {
          "resourceType": "document",
          "budget": ${budget.html}
        },
        {
          "resourceType": "script",
          "budget": ${budget.javascript}
        },
        {
          "resourceType": "image",
          "budget": ${budget.images}
        },
        {
          "resourceType": "stylesheet",
          "budget": ${budget.css}
        },
        {
          "resourceType": "media",
          "budget": ${budget.video}
        },
        {
          "resourceType": "font",
          "budget": ${budget.fonts}
        },
        {
          "resourceType": "total",
          "budget": ${total}
        }
      ]
    }
  ]`;
}
exports.default = (budget, path) => {
    const json = buildJson(budget);
    fs_1.writeFileSync(path, json);
    return;
};
